VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "System Tray Organizer"
   ClientHeight    =   4995
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   7920
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4995
   ScaleWidth      =   7920
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "Set Display"
      Height          =   345
      Left            =   6120
      TabIndex        =   13
      Top             =   3270
      Width           =   1755
   End
   Begin VB.CommandButton cmdManage 
      Caption         =   "< Release"
      Height          =   345
      Index           =   1
      Left            =   1980
      TabIndex        =   12
      Top             =   2865
      Width           =   1755
   End
   Begin VB.CommandButton cmdManage 
      Caption         =   "Manage >"
      Height          =   345
      Index           =   0
      Left            =   60
      TabIndex        =   11
      Top             =   2865
      Width           =   1755
   End
   Begin VB.OptionButton optDisplay 
      Caption         =   "Restore"
      Height          =   270
      Index           =   1
      Left            =   4845
      TabIndex        =   10
      Top             =   3307
      Width           =   1185
   End
   Begin VB.OptionButton optDisplay 
      Caption         =   "Hide"
      Height          =   270
      Index           =   0
      Left            =   3705
      TabIndex        =   9
      Top             =   3307
      Value           =   -1  'True
      Width           =   1185
   End
   Begin VB.ListBox lstManaged 
      Height          =   1320
      Left            =   60
      Sorted          =   -1  'True
      TabIndex        =   8
      Top             =   3645
      Width           =   7815
   End
   Begin VB.TextBox txtClassName 
      Height          =   345
      Left            =   4200
      TabIndex        =   4
      Top             =   2475
      Width           =   3675
   End
   Begin VB.TextBox txtWindowTitle 
      Height          =   345
      Left            =   60
      TabIndex        =   3
      Top             =   2475
      Width           =   3675
   End
   Begin VB.ListBox lstWindows 
      Height          =   1320
      Left            =   60
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   420
      Width           =   7815
   End
   Begin VB.Label lblManagedWindows 
      Caption         =   "Currently Managed Windows"
      Height          =   315
      Left            =   60
      TabIndex        =   7
      Top             =   3285
      Width           =   3105
   End
   Begin VB.Label lblClassName 
      Caption         =   "Class Name"
      Height          =   345
      Left            =   4200
      TabIndex        =   6
      Top             =   2160
      Width           =   3675
   End
   Begin VB.Label lblWindowTitle 
      Caption         =   "Window Title"
      Height          =   345
      Left            =   60
      TabIndex        =   5
      Top             =   2160
      Width           =   3675
   End
   Begin VB.Label lblActiveWindows 
      Caption         =   "Currently Active Windows"
      Height          =   315
      Left            =   60
      TabIndex        =   2
      Top             =   60
      Width           =   7815
   End
   Begin VB.Label lblConfigMsg 
      Caption         =   "Hide this window when it is created ..."
      Height          =   345
      Left            =   60
      TabIndex        =   1
      Top             =   1785
      Width           =   7815
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const clngPicDefault        As Long = 100&
Private Const clngPicDelWindow      As Long = 102&
Private Const clngPicNewWindow      As Long = 101&
Private Const cintWindowText        As Integer = 0
Private Const cintClassName         As Integer = 1
Private Const lngSleep              As Long = 64&

Private Const LB_SETTABSTOPS        As Long = 402&
Private Const LB_FINDSTRINGEXACT    As Long = 418&

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long

Private mobjApplications            As clsApplications

Private WithEvents mobjSysTray      As ISysTray
Attribute mobjSysTray.VB_VarHelpID = -1
Private WithEvents mobjWindows      As IWindows
Attribute mobjWindows.VB_VarHelpID = -1

Private mblnRestore                 As Boolean

Private Sub cmdDisplay_Click()
    Dim objApplication      As clsApplication
    Dim objInstance         As clsInstance
    Dim daDisplay           As DisplayAs
    Dim strDisplayText      As String
    Dim blnShow             As Boolean
    strDisplayText = lstManaged.List(lstManaged.ListIndex)
    If Len(Trim$(strDisplayText)) = 0 Then Exit Sub
    Set objApplication = mobjApplications(strDisplayText)
    If objApplication Is Nothing Then Exit Sub
    If objApplication.InstanceCount = 1 Then
        If mblnRestore Then daDisplay = daNormalActive Else daDisplay = daHide
        objApplication.LastInstance.Display = daDisplay
        mobjWindows.Display objApplication.LastInstance.hWnd, daDisplay
    ElseIf objApplication.InstanceCount > 1 Then
        frmInstances.ShowInstances Me, objApplication, False, mblnRestore
        Unload frmInstances
        For Each objInstance In objApplication
            mobjWindows.Display objInstance.hWnd, objInstance.Display
        Next
    End If
    MoveTop
End Sub

Private Sub cmdManage_Click(Index As Integer)
    On Error Resume Next
    Dim objApplication      As clsApplication
    Dim objInstance         As clsInstance
    Dim objWindow           As IWindow
    Dim strDisplayText      As String
    Dim strWindowTitle      As String
    Dim strClassName        As String
    strWindowTitle = txtWindowTitle.Text
    strClassName = txtClassName.Text
    strDisplayText = strWindowTitle & vbTab & strClassName
    Set objApplication = mobjApplications(strDisplayText)
    Select Case Index
        Case 0
            If objApplication Is Nothing Then
                Set objApplication = mobjApplications.Add(strDisplayText, strWindowTitle, strClassName)
                AddListBoxItem lstManaged, strWindowTitle & vbTab & strClassName, blnAllowDuplicates:=False
                For Each objWindow In mobjWindows
                    If objWindow.WindowTitle & vbTab & objWindow.ClassName = strDisplayText Then
                        objApplication.AddInstance objWindow.hWnd
                        mobjWindows.Display objWindow.hWnd, daHide
                    End If
                Next
            End If
        Case 1
            If Not objApplication Is Nothing Then
                If objApplication.InstanceCount = 1 Then
                    objApplication.RemoveInstance objApplication.LastInstance.hWnd
                ElseIf objApplication.InstanceCount > 1 Then
                    frmInstances.ShowInstances Me, objApplication, blnShow:=True
                    Unload frmInstances
                    For Each objInstance In objApplication
                        If objInstance.Mark Then
                            objApplication.RemoveInstance objInstance.hWnd
                        End If
                    Next
                End If
                If objApplication.InstanceCount = 0 Then
                    mobjApplications.Remove objApplication.DisplayText
                    RemoveListBoxItem lstManaged, strWindowTitle & vbTab & strClassName
                    cmdManage(0).Enabled = True
                    cmdManage(1).Enabled = False
                End If
            End If
    End Select
    Set objApplication = Nothing
End Sub

Private Sub Form_Load()
    Hide
    Set Icon = LoadResPicture(clngPicDefault, vbResIcon)
    Set mobjSysTray = New ISysTray
    mobjSysTray.IconToTray hWnd, Icon, Caption
    Set mobjWindows = New IWindows
    Set mobjApplications = New clsApplications
    FillListAllWindows lstWindows
    FillListManagedWindows lstManaged
End Sub

Private Sub Form_Resize()
    If WindowState = vbMinimized Then
        mobjWindows.Display hWnd, daHide
        WindowState = vbNormal
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim objApplication      As clsApplication
    Dim objInstance         As clsInstance
    If mobjApplications.Count > 0 Then
        If MsgBox("Restore Managed Application Instance(s)?", vbYesNo, "System Tray Organizer") = vbYes Then
            For Each objApplication In mobjApplications
                For Each objInstance In objApplication
                    mobjWindows.Display objInstance.hWnd, daNormalActive
                Next
            Next
        End If
    End If
    SaveManagedWindows lstManaged
    Set mobjSysTray = Nothing
    Set mobjWindows = Nothing
    Set mobjApplications = Nothing
End Sub

Private Sub lstManaged_Click()
    Dim strDisplayText      As String
    Dim strWindowTitle      As String
    Dim strClassName        As String
    strDisplayText = lstManaged.List(lstManaged.ListIndex)
    If Len(Trim$(strDisplayText)) = 0 Then Exit Sub
    GetWindowNames strDisplayText, strWindowTitle, strClassName
    txtWindowTitle.Text = strWindowTitle
    txtClassName.Text = strClassName
    cmdManage(0).Enabled = False
    cmdManage(1).Enabled = True
End Sub

Private Sub lstWindows_Click()
    Dim strDisplayText      As String
    Dim strWindowTitle      As String
    Dim strClassName        As String
    strDisplayText = lstWindows.List(lstWindows.ListIndex)
    If Len(Trim$(strDisplayText)) = 0 Then Exit Sub
    GetWindowNames strDisplayText, strWindowTitle, strClassName
    txtWindowTitle.Text = strWindowTitle
    txtClassName.Text = strClassName
    cmdManage(1).Enabled = False
    cmdManage(0).Enabled = True
End Sub

Private Sub optDisplay_Click(Index As Integer)
    mblnRestore = Index = 1
End Sub

Private Sub FillListAllWindows(ByRef lstListBox As ListBox)
    On Error Resume Next
    Dim objWindow           As IWindow
    MousePointer = vbHourglass
    lstListBox.Clear
    For Each objWindow In mobjWindows
        With objWindow
            AddListBoxItem lstListBox, .WindowTitle & vbTab & .ClassName, .hWnd
        End With
    Next
    lstListBox.ListIndex = 0
    MousePointer = vbDefault
End Sub

Private Sub FillListManagedWindows(ByRef lstListBox As ListBox)
    On Error Resume Next
    Dim objApplication      As clsApplication
    Dim objWindow           As IWindow
    Dim vntSettings         As Variant
    Dim strDisplayText      As String
    Dim strWindowText       As String
    Dim strClassName        As String
    Dim lngPtr              As Long
    MousePointer = vbHourglass
    lstListBox.Clear
    vntSettings = GetAllSettings("System Tray Organizer", "Managed Windows")
    For lngPtr = LBound(vntSettings, 1) To UBound(vntSettings, 1)
        If Err.Number Then Exit Sub
        strDisplayText = vntSettings(lngPtr, 0)
        GetWindowNames strDisplayText, strWindowText, strClassName
        Set objApplication = mobjApplications.Add(strDisplayText, strWindowText, strClassName)
        AddListBoxItem lstListBox, strDisplayText, blnAllowDuplicates:=False
        For Each objWindow In mobjWindows
            strDisplayText = objWindow.WindowTitle & vbTab & objWindow.ClassName
            If SendMessage(lstListBox.hWnd, LB_FINDSTRINGEXACT, 0&, ByVal strDisplayText) > -1 Then
                objApplication.AddInstance objWindow.hWnd
                mobjWindows.Display objWindow.hWnd, daHide
            End If
        Next
    Next
    Set objApplication = Nothing
    MousePointer = vbDefault
End Sub

Private Sub SaveManagedWindows(ByRef lstListBox As ListBox)
    On Error Resume Next
    Dim lngPtr              As Long
    DeleteSetting "System Tray Organizer", "Managed Windows"
    For lngPtr = 0 To lstListBox.ListCount - 1
        SaveSetting "System Tray Organizer", "Managed Windows", lstListBox.List(lngPtr), "1"
    Next
End Sub

Private Sub AddListBoxItem(ByRef lstListBox As ListBox, ByVal strDisplayText As String, Optional ByVal lngHwnd As Long, Optional ByVal blnAllowDuplicates As Boolean = True)
    Dim aryTabStops(0 To 1) As Long
    aryTabStops(0) = 0
    aryTabStops(1) = 200
    With lstListBox
        SendMessage .hWnd, LB_SETTABSTOPS, 2, aryTabStops(0)
        If blnAllowDuplicates Then
            .AddItem strDisplayText
        Else
            If SendMessage(lstListBox.hWnd, LB_FINDSTRINGEXACT, 0&, ByVal strDisplayText) < 0 Then
                .AddItem strDisplayText
            End If
        End If
        If lngHwnd Then
            .ItemData(.NewIndex) = lngHwnd
        End If
    End With
    Erase aryTabStops
End Sub

Private Sub RemoveListBoxItem(ByRef lstListBox As ListBox, ByVal strDisplayText As String, Optional ByVal lngHwnd As Long)
    Dim lngPtr              As Long
    For lngPtr = 0 To lstListBox.ListCount - 1
        With lstListBox
            If .List(lngPtr) = strDisplayText Then
                If lngHwnd = 0 Then
                    .RemoveItem lngPtr
                    Exit For
                ElseIf .ItemData(lngPtr) = lngHwnd Then
                    .RemoveItem lngPtr
                    Exit For
                End If
            End If
        End With
    Next
End Sub

Private Sub GetWindowNames(ByVal strDisplayText As String, Optional ByRef strWindowTitle As String, Optional ByRef strClassName As String)
    On Error Resume Next
    Dim aryDisplayText()    As String
    aryDisplayText = Split(strDisplayText, vbTab)
    strWindowTitle = aryDisplayText(cintWindowText)
    strClassName = aryDisplayText(cintClassName)
End Sub

Private Sub MoveTop()
    SetForegroundWindow hWnd
End Sub

Private Sub mobjWindows_WindowChange(ByVal hWnd As Long, ByVal strWindowTitle As String, ByVal strClassName As String, ByVal wmMessage As wndcd.WindowMessage)
    Dim picStdPic           As StdPicture
    Dim objApplication      As clsApplication
    Dim objInstance         As clsInstance
    Dim strDisplayText      As String
    If Me.hWnd = hWnd Then Exit Sub
    strDisplayText = strWindowTitle & vbTab & strClassName
    Set objApplication = mobjApplications(strDisplayText)
    Select Case wmMessage
        Case wmWindowCreated
            Set Icon = LoadResPicture(clngPicNewWindow, vbResIcon)
            mobjSysTray.IconModifyTray Icon
            AddListBoxItem lstWindows, strDisplayText, hWnd
            If Not objApplication Is Nothing Then
                Set objInstance = objApplication.AddInstance(hWnd)
                If objInstance.Display = ldHide Then
                    mobjWindows.Display objInstance.hWnd, daHide
                End If
            End If
        Case wmWindowDestroyed
            Set Icon = LoadResPicture(clngPicDelWindow, vbResIcon)
            mobjSysTray.IconModifyTray Icon
            RemoveListBoxItem lstWindows, strDisplayText, hWnd
            If Not objApplication Is Nothing Then
                If objApplication(hWnd).Mark Then
                    objApplication.RemoveInstance hWnd
                End If
            End If
    End Select
    FillListAllWindows lstWindows
    Set Icon = LoadResPicture(clngPicDefault, vbResIcon)
    Sleep lngSleep
    mobjSysTray.IconModifyTray Icon
End Sub

Private Sub mobjSysTray_MouseClick(ByVal mbButton As MouseButtonConstants, ByVal bsState As ButtonState)
    If mbButton = vbLeftButton And bsState = bsDblClk Then
        mobjWindows.Display hWnd, daNormalActive
        MoveTop
    End If
End Sub
